/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 * 
 *  Copyright (C) 2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2013,2015 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: prc_config.h 1304 2008-08-27 07:28:36Z ertl-honda $
 */

/*
 *		ץå¸⥸塼ARM-Mѡ
 *
 *  Υ󥯥롼ɥեϡtarget_config.hʤޤϡ饤
 *  롼ɤեˤΤߤ饤󥯥롼ɤ롥¾Υե뤫
 *  ľܥ󥯥롼ɤƤϤʤʤ
 */

#ifndef TOPPERS_PRC_CONFIG_H
#define TOPPERS_PRC_CONFIG_H

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ץåü̿Υ饤ؿ
 */
#include "prc_insn.h"

/*
 *  󥿥ƥѤΥå
 */
#define TOPPERS_ISTKPT(istk, istksz) ((STK_T *)((char *)(istk) + (istksz)))

#endif /* TOPPERS_MACRO_ONLY */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ߥͥȿ
 */
extern uint8_t intnest;

/*
 *  ƥȤλ
 *
 */
Inline bool_t
sense_context(void)
{
	bool_t tskctx;
	
	if (intnest == 0u){
		tskctx = false;
	}
	else {
		tskctx = true;
	}
	
	return tskctx;
}

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  TOPPERSɸ߽ǥμ¸
 *
 *  ARMv6-MƥˤBASEPRIFAULTMASK ¸ߤʤ
 *  ͥ٥ޥ٥ѹ򥽥եȥǹԤȤǤʤᡤ
 *  CPUå֤ˤĤƤPRIMASKˤ롥
 *  ơNMIʳΥͥγߤϥݡȤʤ
 *  ƱͤˡߥåPRIMASKǼ¸롥
 */

/*
 *  ͥ٥ޥγɽɽѴ
 *
 *  ֥Υե뤫饤󥯥롼ɤΤˡ
 *  CAST
 *  ͥ٤Υӥå(TBITW_IPRI) 8 ξϡͥ 255
 *  ϡͥ -1 б롥
 */
#define EXT_IPM(iipm)   (CAST(PRI,((iipm >> (8 - TBITW_IPRI)) - (1 << TBITW_IPRI))))       /* ɽɽ */
#define INT_IPM(ipm)    (((1 << TBITW_IPRI) - CAST(uint8_t, -(ipm)))  << (8 - TBITW_IPRI)) /* ɽɽ */

/*
 *  CPUå֤Ǥγͥ٥ޥ
 */
#define TIPM_LOCK    TMIN_INTPRI


#ifndef TOPPERS_MACRO_ONLY

/*
 *  CPUå֤ؤΰܹ
 *
 *  PRIMASKPMӥåȤ1ˤ롥
 */
Inline void
x_lock_cpu(void)
{
	Asm("cpsid i":::"memory");
}

#define t_lock_cpu()    x_lock_cpu()
#define i_lock_cpu()    x_lock_cpu()

/*
 *  CPUå֤β
 *
 *  PRIMASKPMӥåȤ0ˤ롥
 */
Inline void
x_unlock_cpu(void)
{
	Asm("cpsie i":::"memory");
}

#define t_unlock_cpu()    x_unlock_cpu()
#define i_unlock_cpu()    x_unlock_cpu()

/*
 *  CPUå֤λ
 */
Inline bool_t
x_sense_lock(void)
{
	uint32_t val;

	Asm("mrs  %0, PRIMASK" : "=r"(val));

	if (val == 1) {
		return (true);
	}
	else {
		return (false);
	}
}

#define t_sense_lock()    x_sense_lock()
#define i_sense_lock()    x_sense_lock()


/*
 * ʥǥΡ˳ͥ٥ޥ
 *
 *  ͥ٥ޥץफѹ뤳ȤǤʤᡤ
 *  ǤϤʤˤ⤷ʤ
 */
Inline void
x_set_ipm(PRI intpri)
{
}

#define t_set_ipm(intpri)    x_set_ipm(intpri)
#define i_set_ipm(intpri)    x_set_ipm(intpri)

/*
 * ʥǥΡ˳ͥ٥ޥλ
 *
 *  ޥͤץफꡤ뤳ȤϤǤʤᡤ
 *  ǤŬ֤ͤ
 */
Inline PRI
x_get_ipm(void)
{
	return(TMAX_INTPRI);
}

#define t_get_ipm()    x_get_ipm()
#define i_get_ipm()    x_get_ipm()

/*
 *  SVCϥɥprc_support.S
 */
extern void svc_handler(void);

/*
 *  ȥåץ롼start.S
 */
extern void _start(void);

/*
 *  ǥѥåưϡprc_support.S
 *
 *  start_dispatchϡͥ뵯ư˸ƤӽФ٤Τǡ٤Ƥγ
 *  ߤػߤ֡ʳߥå֤Ʊξ֡ˤǸƤӽФʤ
 *  ʤʤ
 */
extern void start_dispatch(void) NoReturn;


/*
 *  ͥνλθƽФprc_support.S
 *
 *  call_exit_kernelϡͥνλ˸ƤӽФ٤Τǡ󥿥
 *  ƥȤڤ괹ơͥνλexit_kernelˤƤӽ
 *  
 */
extern void call_exit_kernel(void) NoReturn;

/*
 *  ɥ롼פμ
 *
 *  ñCPUå֤CPUå֤ƤӽФȤ롥
 *  ꡼ץ⡼ɤܽwfi̿Ѥƽ񤭴ɤ
 */
Inline void
idle_loop(void)
{
	/* CPUå => CPUå  */
	i_unlock_cpu();
	i_lock_cpu();
}

/*
 *  ֹ桦ߥϥɥֹ
 *
 *  ߥϥɥֹ(inhno)ȳֹ(intno)ϡȯ
 *  EPSRꤵ㳰ֹȤ롥
 */

/*
 *  ֹϰϤȽ
 */
#define VALID_INTNO(intno)           ((TMIN_INTNO <= (intno)) && ((intno) <= TMAX_INTNO))
#define VALID_INTNO_DISINT(intno)    VALID_INTNO(intno)
#define VALID_INTNO_CFGINT(intno)    VALID_INTNO(intno)

/*
 *  ߥϥɥ
 *
 *  ٥ȥֹinhnoγߥϥɥεưint_entryꤹ롥
 *  ϥɥơ֥
 */
Inline void
x_define_inh(INHNO inhno, FP int_entry)
{
	/* ä˹ԤϤʤ */
}

/*
 *  ߥϥɥνޥ
 *
 */
#define INT_ENTRY(inhno, inthdr)    inthdr
#define INTHDR_ENTRY(inhno, inhno_num, inthdr) extern void inthdr(void);

/*
 *  ׵ػߥե饰
 */

/*
 *  °ꤵƤ뤫Ƚ̤뤿ѿkernel_cfg.c
 */
extern const uint32_t	bitpat_cfgint[];

/*
 *  ׵ػߥե饰Υå
 *
 *  °ꤵƤʤ׵饤ФƳ׵ػ
 *  ե饰򥯥ꥢ褦Ȥˤϡfalse֤
 */
Inline bool_t
x_disable_int(INTNO intno)
{
	uint32_t tmp;

	/*
	 *  °ꤵƤʤ
	 */
	if ((bitpat_cfgint[intno >> 5] & (1 << (intno & 0x1f))) == 0x00) {
		return(false);
	}

	if (intno == IRQNO_SYSTICK) {
		tmp = sil_rew_mem((void *)SYSTIC_CONTROL_STATUS);
		tmp &= ~SYSTIC_TICINT;
		sil_wrw_mem((void *)SYSTIC_CONTROL_STATUS, tmp);
	}else {
		tmp = intno - 16;
		sil_wrw_mem((void *)NVIC_CLRENA0 + (tmp >> 5), (1 << (tmp & 0x1f)));
	}

	return(true);
}

#define t_disable_int(intno) x_disable_int(intno)
#define i_disable_int(intno) x_disable_int(intno)

/*
 *  ׵ػߥե饰β
 *
 *  °ꤵƤʤ׵饤ФƳ׵ػ
 *  ե饰򥯥ꥢ褦Ȥˤϡfalse֤
 */
Inline bool_t
x_enable_int(INTNO intno)
{
	uint32_t tmp;

	/*
	 *  °ꤵƤʤ
	 */
	if ((bitpat_cfgint[intno >> 5] & (1 << (intno & 0x1f))) == 0x00) {
		return(false);
	}

	if (intno == IRQNO_SYSTICK) {
		tmp = sil_rew_mem((void *)SYSTIC_CONTROL_STATUS);
		tmp |= SYSTIC_TICINT;
		sil_wrw_mem((void *)SYSTIC_CONTROL_STATUS, tmp);
	}else {
		tmp = intno - 16;
		sil_wrw_mem((void *)((uint32_t *)NVIC_SETENA0 + (tmp >> 5)),
					(1 << (tmp & 0x1f)));
	}
    
	return(true);
}

#define t_enable_int(intno) x_enable_int(intno)
#define i_enable_int(intno) x_enable_int(intno)

Inline void
x_clear_int(INTNO intno)
{
	uint32_t tmp;
	
	if (intno != IRQNO_SYSTICK) {
		tmp = intno - 16;
		sil_wrw_mem((void *)((uint32_t *)NVIC_CLRENA0 + (tmp >> 5)),
					(1 << (tmp & 0x1f)));
	}
}

/*
 *  ׵饤°
 */
extern void x_config_int(INTNO intno, ATR intatr, PRI intpri);

/*
 *  ߥϥɥɬפIRC
 */
Inline void
i_begin_int(INTNO intno)
{
	/* ä˹ԤϤʤ */
}

/*
 *  ߥϥɥνиɬפIRC
 */
Inline void
i_end_int(INTNO intno)
{
	/* ä˹ԤϤʤ */
}

/*
 *  CPU㳰ϥɥط
 */ 

/*
 *  CPU㳰ϥɥֹ
 */
#define VALID_EXCNO_DEFEXC(excno)    (TMIN_EXCNO <= (excno) && (excno) <= TMAX_EXCNO)

/*
 *  CPU㳰ϥɥε
 */
extern void enable_exc(EXCNO excno);

/*
 *  CPU㳰ϥɥζػ
 */
extern void disable_exc(EXCNO excno);

/*
 *  CPU㳰ϥɥ
 */
Inline void
x_define_exc(EXCNO excno, FP exc_entry)
{
	/*
	 *  㳰ϵĤԤɬפ
	 */
	enable_exc(excno);
}

/*
 *  CPU㳰ϥɥޥ
 */
#define EXC_ENTRY(excno, exchdr)    exchdr
#define EXCHDR_ENTRY(excno, excno_num, exchdr) extern void exchdr(void *p_excinf);


/*
 *  CPU㳰ȥprc_support.S
 */
extern void exc_entry(void);

/*
 *  ߥȥprc_support.S
 */
extern void int_entry(void);

/*
 *  ץå¸ν
 */
extern void prc_initialize(void);

/*
 *  ץå¸νλ
 */
extern void prc_terminate(void) NoReturn;

/*
 *  atexitνȥǥȥ饯μ¹
 */
Inline void
call_atexit(void)
{
	extern void    software_term_hook(void);
	void (*volatile fp)(void) = software_term_hook;

	/*
	 *  software_term_hookؤΥݥ󥿤򡤰övolatileΤfp
	 *  ƤȤΤϡ0ȤӤŬǺʤ褦ˤ뤿
	 *  Ǥ롥
	 */
	if (fp != 0) {
		(*fp)();
	}
}

/*
 * ϿƤʤ㳰ȯȸƤӽФ
 */
extern void default_exc_handler(void *p_excinf);

/*
 * ̤Ͽγߤȯ˸ƤӽФ
 */
extern void default_int_handler(void *p_excinf);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_PRC_CONFIG_H */
